# -*- coding: utf-8 -*-

#####################################################################################################
### Matrices A et B caractéristiques du système de 21 équations à 21 inconnues #####
#####################################################################################################

A=[[1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 1.0, 0.0, 16.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, -1.5, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -3.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 3.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0]]
B=[[0.0], [0.0], [245250.0], [2943000.0], [-147150.0], [0.0], [0.0], [0.0], [0.0], [147150.0], [0.0], [0.0], [36787.5], [331087.5], [147150.0], [0.0], [0.0], [0.0], [-183937.5], [0.0], [0.0]]

#####################################################################################################
### Algorithme du pivot de Gauss #####
#####################################################################################################


def echange(A, i, j):
    """
    A est une matrice

    Echange les lignes i et j dans A.
    """
    temp = A[i].copy()
    A[i] = A[j]
    A[j] = temp


def multiplie(A, i, k):
    """
    Multiplie la ligne i de la matrice A par une constante k non nulle.

    Ne fonctionne que si A est un np.array
    """
    if k == 0:
        return
    A[i] = k * A[i]


def combinaison(A, i, j, c):
    """
    Ajoute c fois la ligne j à la ligne i dans A.
    i doit être différent de j
    """
    return


def cherche_pivot_colonne(A, j, ligne_min):
    """
    Trouve un pivot dans la colonne j de A en dessous (<=) de ligne_min.

    Retourne l'indice de la ligne trouvée ou -1 si tous les coefficients de
    la colonne sont nuls.
    """
    for k in range(ligne_min, len(A)):
        if A[k][j] != 0:
            return k
    return -1


def echelonne(A, B):
    """
    Echelonne la matrice A par l'algorithme du pivot de Gauss.
    Reporte les opérations sur la matrice B si une matrice est donnée.

    On traite le problème général d'une matrice A pas forcément carrée ni inversible.
    """
    n = len(A)  # n lingnes
    p = len(A[0])  # p colonnes
    l, c = 0, 0  # ligne et colonne courante
    while (l < n) and (c < p):
        k = cherche_pivot_colonne(A, c, l)
        if k != -1:  # sinon tous les coefficients de cette colonne sont nuls
            if k != l:
                echange(A, l, k)
                echange(B, l, k)
            for i in range(l + 1, n):
                coeff = -A[i][c] / A[l][c]
                combinaison(B, i, l, coeff)
                combinaison(A, i, l, coeff)
            l = l + 1  # on ne change de ligne que lorsque la colonne c est non nulle.
        c = c + 1  # on change systématiquement de colonne.
    return A, B


def cherche_pivot_ligne(A, i):
    """
    Trouve l'indice de colonne du premier coefficient non nul dans la ligne i de la matrice A

    Retourne cet indice ou -1 si la ligne est nulle.
    """
    return -1


def reduit(A, B):
    """
    Reduit la matrice échelonnée A et reporte les opération sur B.
    """
    l = len(A) - 1  # numero de la ligne courante
    while l >= 0:
        c = cherche_pivot_ligne(A, l)
        if c != -1:
            # opération dans B d'abord, car on modifie A au passage...
            multiplie(B, l, 1 / A[l][c])
            multiplie(A, l, 1 / A[l][c])
            for i in range(0, l):  # pour les lignes au dessus
                combinaison(B, i, l, -A[i][c])
                combinaison(A, i, l, -A[i][c])
        l = l - 1
    return A, B


def resoudre(A, B):
    """
    Ici on suppose qu'il existe une unique solution au système AX = B
    resout(A, B) retourne cette unique solution

    Retourne cette unique solution. On prendra garde à copier les matrices A et B
    avant de lancer nos fonctions.
    La commande A.copy() retourne une copie du vecteur numpy A.
    """
    return B


##### Test
#
#A1 = [[1,2,3],[3,1,2],[2,3,1]]
#
#print(A1)
#echange(A1, 0, 1)
#print(A1)
#multiplie(A1, 1, 10)
#print(A1)
#combinaison(A1, 1, 2, 100)
#print(A1)
#print(cherche_pivot_colonne(A1, 1, 0))
#print(echelonne(A1))
#print(A1)
